Part Offset2D/pl: Difference between revisions

From FreeCAD Documentation
(Created page with "Polilinia / ściana musi być płaska. W jednym obiekcie może znajdować się wiele przewodów, niekoniecznie współpłaszczyznowych.")
(Created page with "==Uwagi==")
Line 31: Line 31:
==Użycie==
==Użycie==


# Wybierz obiekt do przesunięcia.
# Select an object to offset.
# Press the {{Button|[[Image:Part_Offset2D.svg|16px]] [[Part_Offset2D|2D Offset]]}} button.
# Naciśnij przycisk {{Button|[[Image:Part_Offset2D.svg|16px]] [[Part_Offset2D/pl|Odsunięcie 2D]]}}.
# Set up the offset in the [[Task_panel|Task Panel]].
# Ustaw przesunięcie w oknie [[Task_panel/pl|Panelu zadań]].
# Press {{Button|OK}}.
# Naciśnij {{Button|OK}}.


==Notes==
<span id="Notes"></span>
==Uwagi==


* [[App_Link|App Link]] objects linked to the appropriate object types and [[App_Part|App Part]] containers with the appropriate visible objects inside can also be used as source objects. {{Version|0.20}}
* [[App_Link|App Link]] objects linked to the appropriate object types and [[App_Part|App Part]] containers with the appropriate visible objects inside can also be used as source objects. {{Version|0.20}}

Revision as of 20:30, 27 June 2023

Część: Odsunięcie 2D

Lokalizacja w menu
Część → Odsunięcie 2D
Środowisko pracy
Część
Domyślny skrót
brak
Wprowadzono w wersji
0.17
Zobacz także
Odsunięcie 3D, Grubość, Odsunięcie

Opis

Narzędzie Offset 2D tworzy polilinię równoległą do oryginalnej polilinii w pewnej odległości od niej. Lub powiększa/zmniejsza płaską ścianę, w podobny sposób.

Polilinia / ściana musi być płaska. W jednym obiekcie może znajdować się wiele przewodów, niekoniecznie współpłaszczyznowych.

Użycie

  1. Wybierz obiekt do przesunięcia.
  2. Naciśnij przycisk Odsunięcie 2D.
  3. Ustaw przesunięcie w oknie Panelu zadań.
  4. Naciśnij OK.

Uwagi

Known issues

  • Most of non-default modes will only work with OCC 7.0.0 or later.
  • Using the tool can crash FreeCAD (see next point). On Windows, these crashes are converted to exceptions and don't generally cause FreeCAD to close; on other OS'es it is not the case, so it is advisable to save project before attempting to use the tool. Ellipses are not handled either.
  • Enlarging faces with circular holes by an amount large enough to cause holes to close up, a crash occurs (OCC 7.0.0). The problem seems to be specific to circles; other shapes seem to close out properly.
  • When offsetting circles that have non-zero Placement, the result is placed wrongly. (OCC 7.0.0)
  • When offsetting circles, sometimes they are offset in unexpected direction (e.g. inward instead of outward). (OCC 7.0.0)
  • Fill="true" doesn't work when collectively offsetting open wires in "Skin" mode
  • "Tangent" join mode doesn't work (OCC 7.0.0)
  • Offsetting wires made of single line segment is not supported (because line segment doesn't define a plane). Single line segments cannot participate in collective offset either.

Properties

  • DANESource: Link to original shape
  • DANEValue: The distance to enlarge the wire/face by. If negative, the wire/face is shrunk instead.
  • DANEMode ("Pipe" or "Skin"): sets how non-closed wires are processed. If "Pipe", the wire is outlined as if it was an extremely thin closed contour. If "Skin", an open wire is created.
  • DANEJoin ("Arc", "Tangent", "Intersection"): sets the behavior around kinks. If "Arc", offset segments are connected with an arc of circle, centered at the vertex. "Tangent" is unsupported on OCC7.0.0. "Intersection": offset segments are extended till they intersect.
  • DANEIntersection ("false", "true"): sets if multiple wires are treated collectively or independently. If "false", wires are offset independently, intersections between resulting wires are ignored. If "true", the wires are offset in collective manner.
Only wires within a compound are coupled. For example, if the structure is like compound(wire1, wire2, compound(wire3, wire4)), wire1 and wire2 will be treated collectively, but independently from wire3 and wire4. Likewise, wire3 and wire4 are treated collectively, but independently of wire1+wire2.
Also, in collective mode, directions of wires are important, and influence direction of offset. This is in tight relationship with how holes in faces are treated.
Wires being treated collectively must be coplanar. Wires being offset independently don't have to be coplanar.
  • DANEFill ("false", "true"): if "true", the space between original wire/face and the offset is filled with a face.

Tworzenie skryptów

Narzędzie Odsunięcie 2D może być używane w makrodefinicjach i z konsoli Python za pomocą następującej funkcji:

f = App.ActiveDocument.addObject("Part::Offset2D", "Offset2D")
f.Source =  #some object
f.Value = 10.0

Odsunięcie 2D jest również dostępne jako metoda Part.Shape. Przykład:

import Part
circle = Part.Circle().toShape()
enlarged_circle = circle.makeOffset2D(10.0)
Part.show(circle)
Part.show(enlarged_circle)
# makeOffset2D(offset, join = 0, fill = False, openResult = false, intersection = false)
# 
# * offset: distance to expand the shape by. 
# 
# * join: method of offsetting non-tangent joints. 0 = arcs, 1 = tangent, 2 =
# intersection
# 
# * fill: if true, the output is a face filling the space covered by offset. If
# false, the output is a wire/face.
# 
# * openResult: True for "Skin" mode; False for Pipe mode. 
# 
# * intersection: collective offset
# 
# Returns: result of offsetting (wire or face or compound of those). Compounding
# structure follows that of source shape.